<?php
$ab_module = isset($GO_MODULES->modules['addressbook']) ? $GO_MODULES->modules['addressbook'] : false;
if ($ab_module && $ab_module['read_permission'])
{
	require_once($ab_module['class_path'].'addressbook.class.inc');
	$ab = new addressbook();
}

$projects_module = isset($GO_MODULES->modules['projects']) ? $GO_MODULES->modules['projects'] : false;
if ($projects_module && $projects_module['read_permission'])
{
	require_once($projects_module['class_path'].'projects.class.inc');
	$projects = new projects();
}

//show_days is the number of days to show (defined in index.php)
//max_columns (defined in index.php)
if ($cal_settings['show_days'] == 0)
{
	$_REQUEST['show_days'] = 7;
}
if (isset($_REQUEST['show_days']) && ($_REQUEST['show_days'] != $cal_settings['show_days']))
{	
	$cal_settings['show_days'] = $_REQUEST['show_days'];
	$cal->update_settings($cal_settings);
}
if ($cal_settings['show_days'] > 29)
{
	$day = 1;
}
if ($cal_settings['show_days'] > 4)
{
	//calculate the first day to display in the week view.
	$weekday = date("w", mktime(0,0,0,$month, $day, $year));

	$tmpday = $day - $weekday + $_SESSION['GO_SESSION']['first_weekday'];
	if ($tmpday > $day)
	{
		$tmpday = $tmpday -7;
	}
	$org_day = $day;
	$org_month = $month;
	$org_year = $year;

	$new_time = mktime(0,0,0,$month, $tmpday, $year);
	$day = date("j", $new_time);
	$month = date('n', $new_time);
	$year = date('Y', $new_time);
}

$interval_start_time = server_to_gmt_time(mktime(0,0,0,$month, $day, $year));
$interval_end_time = server_to_gmt_time(mktime(0,0,0,$month, $day+$cal_settings['show_days'], $year));

if($cal_settings['show_days'] > 29)
{
	//recalculate the $interval_end_time for the monthly view (for displaying recurrent events)
	$interval_end_time = mktime(0,0,0,$month, $day+$cal_settings['show_days']+7, $year);
}
$timezone_offset = get_timezone_offset($interval_start_time);


if(!$print)
{
	echo '<table border="0" cellpadding="0" cellspacing="0"><tr height="28"><td><h3>';
	echo $sc_view.':&nbsp;</h3></td><td>';
	$dropbox = new dropbox();
	$dropbox->add_value('1', '1 '.$sc_day);
	$dropbox->add_value('2', '2 '.$sc_days);
	$dropbox->add_value('5', '5 '.$sc_days);
	$dropbox->add_value('7', '1 '.$sc_week);
	$dropbox->add_value('14', '2 '.$sc_weeks);
	$dropbox->add_value('21', '3 '.$sc_weeks);
	$dropbox->add_value('35', '1 '.$sc_month);
	$dropbox->print_dropbox("show_days", $cal_settings['show_days'],
	'onchange="javascript:document.forms[0].submit()"');
	if ($cal_settings['show_days'] == 5)
	{
		$interval= 7;
	}else
	{
		$interval = $cal_settings['show_days'];
	}
	$day_view = ($interval == 1) ? true : false;

	// calculate the dates for the navigation (forward/backward) on top
	echo '</td>';
	if($cal_settings['show_days'] > 29)
	{
		echo '<td><h3>&nbsp;&nbsp;<a href="javascript:goto_date('.$org_day.', '.($org_month-1).', '.$org_year.');">&lt;&lt;</a>&nbsp;&nbsp;';
		echo $months[$org_month-1].', '.$org_year;
		echo '&nbsp;&nbsp;<a href="javascript:goto_date('.$org_day.', '.($org_month+1).', '.$org_year.');">&gt;&gt;</a>';
	}else
	{
		echo '<td><h3><a href="javascript:goto_date('.($day-$interval).', '.$month.', '.$year.');">&lt;&lt;</a>&nbsp;';
		echo date($_SESSION['GO_SESSION']['date_format'], $interval_start_time).' - '.
		date($_SESSION['GO_SESSION']['date_format'], mktime(0,0,0,$month, $day+$interval-1,$year)+
		($timezone_offset*3600));
		echo '&nbsp;<a href="javascript:goto_date('.($day+$interval).', '.$month.', '.$year.');">&gt;&gt;</a>';
	}
	echo '</h3></td>';
	echo '</tr></table>';
}


$weeknumber = date("W", mktime(0,0,0,$month,$day,$year));

// calculate the count of needed weeks ($rows) for displaying a whole month
$rows = $cal_settings['show_days']/$max_columns;
if($cal_settings['show_days'] > 29)
{
	$temp_year = $weeknumber >= 52 ? $year+1 : $year;
	$month_days = date("t", mktime(0,0,0,$month,$day+7,$temp_year));
	$month_index = date("n", mktime(0,0,0,$month,$day+7,$temp_year));
	$month_begins_on_weekday = date("w", mktime(0,0,0,$month_index,1,$temp_year));

	switch ($month_days)
	{
		case 28:
		if($_SESSION['GO_SESSION']['first_weekday'] == $month_begins_on_weekday)
		{
			$rows = 4;
		}
		break;
		case 30:
		if($_SESSION['GO_SESSION']['first_weekday'] == 0 && $month_begins_on_weekday == 6
		|| $_SESSION['GO_SESSION']['first_weekday'] == 1 && $month_begins_on_weekday == 0)
		{
			$rows = 6;
		}
		break;
		case 31:
		if($_SESSION['GO_SESSION']['first_weekday'] == 0 && ($month_begins_on_weekday == 5 || $month_begins_on_weekday == 6)
		|| $_SESSION['GO_SESSION']['first_weekday'] == 1 && ($month_begins_on_weekday == 6 || $month_begins_on_weekday == 0))
		{
			$rows = 6;
		}
		break;
		default:
		$rows = 5;
	}
}

// if there are no holidays in database they are automatically generated
if ((array_key_exists($_SESSION['GO_SESSION']['language']['code'], $holidays->in_holidays["fix"]) || 
	array_key_exists($_SESSION['GO_SESSION']['language']['code'], $holidays->in_holidays["var"]) ||
	array_key_exists($_SESSION['GO_SESSION']['language']['code'], $holidays->in_holidays["spc"])) &&
	!empty($calendar_id)) {
	if(!$holidays->get_holidays($GO_SECURITY->user_id, $calendar_id, $year)){
		$holidays->add_holidays($GO_SECURITY->user_id, $calendar_id, $year, $_SESSION['GO_SESSION']['language']['code']);
	}
}

$view_id = isset($view_id) ? $view_id : 0;
$merged_view = isset($merged_view) ? $merged_view : true;

if($merged_view || $view_id == 0)
{
	echo '<table id="cal" width="100%" height="100%">';
	require_once('calendar_view.inc');
}else
{
	if(!$calendars)
	{
		echo '<p>'.$cms_no_calendars_in_view.'</p>';
	}else
	{
		if($day_view)
		{
			$max_cols = 5;
			$count_rows = ceil(count($calendars) / $max_cols);
			$count_cols = floor(count($calendars) / $count_rows);
			$rest = (count($calendars) > $max_cols) ? bcmod(count($calendars), $count_rows) : 0;
			for($row=0;$row<$count_rows;$row++)
			{
				$count_cols_temp = $count_cols;
				if($rest > 0)
				{
					$rest--;
					$count_cols_temp++;
				}
				$sum_cols = isset($sum_cols) ? $sum_cols + $count_cols_temp : $count_cols_temp;
				$cal_count[] = $sum_cols;
				for($col=0;$col<$count_cols_temp;$col++)
				{
					$cal_width[] = floor(100 / $count_cols_temp);
				}
			}

			echo '<table cellpadding="0" cellspacing="0" width="100%" height="100%"><tr>';
		}else
		{
			echo '<table id="cal" width="100%" height="100%">';
		}

		$view_id = 0;
		for($cal_index = 0; $cal_index<count($calendars); $cal_index++)
		{
			$calendar=$calendars[$cal_index];
			$calendar_id = $calendar["id"];
			if($day_view)
			{
				if(in_array($cal_index, $cal_count))
				{
					echo '</tr></table>';
					echo '<table cellpadding="0" cellspacing="0" width="100%" height="100%"><tr>';
				}
				echo '<td width="'.$cal_width[$cal_index].'%" height="100%">';
				echo '<table id="cal" width="100%" height="100%">';
			}

			echo '<tr><td height="100%" colspan="8" class="cal_title">'.$calendar["name"].'</td></tr>';

			require('calendar_view.inc');
			if($day_view)
			{
				echo "</table></td>";
			}
		}
	}
}
if($day_view)
{
	echo "</tr>";
}
echo '</table>';
?>
<script type="text/javascript">

function glow_row(hour)
{
	table_row = get_object(hour);
	table_row.style.backgroundColor = '#FFFFCC';
}

function unglow_row(hour)
{
	table_row = get_object(hour);
	table_row.style.backgroundColor = '';
}
</script>
